//////////////////////////////////////////////////////////////////////////////////////////////////////////////////// 
//  Copyright Syncfusion Inc. 2001 - 2003. All rights reserved. Use of this code is subject to the terms of our 
//  license. A copy of the current license can be obtained at any time by e-mailing licensing@syncfusion.com. 
//  Re-distribution in any form is strictly prohibited. Any infringement will be prosecuted under applicable laws. 
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////// 
 
namespace XPTaskBarSample
{
	using System;
	using System.Drawing;
	using System.Drawing.Drawing2D;
	using System.Collections;
	using System.ComponentModel;
	using System.Windows.Forms;
	using System.Data;
	using Syncfusion.Windows.Forms.Tools;
	using Syncfusion.Windows.Forms;

	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private Syncfusion.Windows.Forms.Tools.XPTaskBarBox taskMenuBox1;
		private System.Windows.Forms.ImageList imageList1;
		private Syncfusion.Windows.Forms.Tools.XPTaskBar xpTaskBar1;
		private Syncfusion.Windows.Forms.Tools.XPTaskBarBox taskMenuBox3;
		private System.Windows.Forms.Label aboutLable;
		private System.Windows.Forms.Label aboutItemsLabel;
		private System.Windows.Forms.Label aboutDrawingLabel;
		private System.Windows.Forms.Panel panel1;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.TextBox textBox1;
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.ComboBox comboBox1;
		private System.Windows.Forms.Button button1;
		private System.Windows.Forms.Label label3;
		private System.Windows.Forms.ImageList headerImageList;
		private System.ComponentModel.IContainer components;
		private bool expanded;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			this.expanded = true;

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.components = new System.ComponentModel.Container();
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(Form1));
			this.taskMenuBox1 = new Syncfusion.Windows.Forms.Tools.XPTaskBarBox();
			this.imageList1 = new System.Windows.Forms.ImageList(this.components);
			this.taskMenuBox3 = new Syncfusion.Windows.Forms.Tools.XPTaskBarBox();
			this.panel1 = new System.Windows.Forms.Panel();
			this.button1 = new System.Windows.Forms.Button();
			this.comboBox1 = new System.Windows.Forms.ComboBox();
			this.label2 = new System.Windows.Forms.Label();
			this.textBox1 = new System.Windows.Forms.TextBox();
			this.label1 = new System.Windows.Forms.Label();
			this.xpTaskBar1 = new Syncfusion.Windows.Forms.Tools.XPTaskBar();
			this.headerImageList = new System.Windows.Forms.ImageList(this.components);
			this.aboutLable = new System.Windows.Forms.Label();
			this.aboutItemsLabel = new System.Windows.Forms.Label();
			this.aboutDrawingLabel = new System.Windows.Forms.Label();
			this.label3 = new System.Windows.Forms.Label();
			this.taskMenuBox3.SuspendLayout();
			this.panel1.SuspendLayout();
			((System.ComponentModel.ISupportInitialize)(this.xpTaskBar1)).BeginInit();
			this.xpTaskBar1.SuspendLayout();
			this.SuspendLayout();
			// 
			// taskMenuBox1
			// 
			this.taskMenuBox1.HeaderBackColor = System.Drawing.Color.LightSteelBlue;
			this.taskMenuBox1.HeaderImageIndex = 0;
			this.taskMenuBox1.ImageList = this.imageList1;
			this.taskMenuBox1.ItemBackColor = System.Drawing.Color.AliceBlue;
			this.taskMenuBox1.Items.AddRange(new Syncfusion.Windows.Forms.Tools.XPTaskBarItem[] {
																									new Syncfusion.Windows.Forms.Tools.XPTaskBarItem("Text, Image and Click Events", System.Drawing.SystemColors.ActiveCaption, 1, "about items"),
																									new Syncfusion.Windows.Forms.Tools.XPTaskBarItem("Drawing Header and Item area with a custom brush.", System.Drawing.Color.Empty, 0, "about drawing")});
			this.taskMenuBox1.Location = new System.Drawing.Point(10, 20);
			this.taskMenuBox1.Name = "taskMenuBox1";
			this.taskMenuBox1.Size = new System.Drawing.Size(196, 103);
			this.taskMenuBox1.TabIndex = 0;
			this.taskMenuBox1.Text = "XPTaskBar Features";
			this.taskMenuBox1.ItemClick += new Syncfusion.Windows.Forms.Tools.XPTaskBarItemClickHandler(this.xpTaskBarBox_ItemClick);
			this.taskMenuBox1.ProvideHeaderBackgroundBrush += new Syncfusion.Windows.Forms.Tools.ProvideBrushEventHandler(this.xpTaskBarBox_ProvideHeaderBackgroundBrush);
			// 
			// imageList1
			// 
			this.imageList1.ColorDepth = System.Windows.Forms.ColorDepth.Depth8Bit;
			this.imageList1.ImageSize = new System.Drawing.Size(16, 16);
			this.imageList1.ImageStream = ((System.Windows.Forms.ImageListStreamer)(resources.GetObject("imageList1.ImageStream")));
			this.imageList1.TransparentColor = System.Drawing.Color.Transparent;
			// 
			// taskMenuBox3
			// 
			this.taskMenuBox3.Controls.AddRange(new System.Windows.Forms.Control[] {
																					   this.panel1});
			this.taskMenuBox3.HeaderBackColor = System.Drawing.Color.RoyalBlue;
			this.taskMenuBox3.HeaderImageIndex = 1;
			this.taskMenuBox3.ItemBackColor = System.Drawing.Color.AliceBlue;
			this.taskMenuBox3.Location = new System.Drawing.Point(10, 133);
			this.taskMenuBox3.Name = "taskMenuBox3";
			this.taskMenuBox3.PreferredChildPanelHeight = 120;
			this.taskMenuBox3.Size = new System.Drawing.Size(196, 166);
			this.taskMenuBox3.TabIndex = 1;
			this.taskMenuBox3.Text = "Advanced Search";
			this.taskMenuBox3.ItemClick += new Syncfusion.Windows.Forms.Tools.XPTaskBarItemClickHandler(this.xpTaskBarBox_ItemClick);
			this.taskMenuBox3.CollapsedStateChanged += new System.EventHandler(this.taskMenuBox3_CollapsedStateChanged);
			// 
			// panel1
			// 
			this.panel1.BackColor = System.Drawing.Color.AliceBlue;
			this.panel1.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.panel1.Controls.AddRange(new System.Windows.Forms.Control[] {
																				 this.button1,
																				 this.comboBox1,
																				 this.label2,
																				 this.textBox1,
																				 this.label1});
			this.panel1.Location = new System.Drawing.Point(2, 44);
			this.panel1.Name = "panel1";
			this.panel1.Size = new System.Drawing.Size(192, 120);
			this.panel1.TabIndex = 0;
			// 
			// button1
			// 
			this.button1.FlatStyle = System.Windows.Forms.FlatStyle.Flat;
			this.button1.Location = new System.Drawing.Point(40, 80);
			this.button1.Name = "button1";
			this.button1.Size = new System.Drawing.Size(88, 24);
			this.button1.TabIndex = 4;
			this.button1.Text = "Search";
			// 
			// comboBox1
			// 
			this.comboBox1.Items.AddRange(new object[] {
														   "C#",
														   "VB",
														   "C++"});
			this.comboBox1.Location = new System.Drawing.Point(64, 40);
			this.comboBox1.Name = "comboBox1";
			this.comboBox1.Size = new System.Drawing.Size(104, 23);
			this.comboBox1.TabIndex = 3;
			this.comboBox1.Text = "comboBox1";
			// 
			// label2
			// 
			this.label2.Location = new System.Drawing.Point(0, 41);
			this.label2.Name = "label2";
			this.label2.Size = new System.Drawing.Size(64, 16);
			this.label2.TabIndex = 2;
			this.label2.Text = "Category:";
			// 
			// textBox1
			// 
			this.textBox1.Location = new System.Drawing.Point(64, 8);
			this.textBox1.Name = "textBox1";
			this.textBox1.TabIndex = 1;
			this.textBox1.Text = "";
			// 
			// label1
			// 
			this.label1.Location = new System.Drawing.Point(0, 8);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(64, 16);
			this.label1.TabIndex = 0;
			this.label1.Text = "Keywords:";
			// 
			// xpTaskBar1
			// 
			this.xpTaskBar1.AutoPersistStates = true;
			this.xpTaskBar1.AutoScroll = true;
			this.xpTaskBar1.BackColor = System.Drawing.Color.FromArgb(((System.Byte)(140)), ((System.Byte)(170)), ((System.Byte)(230)));
			this.xpTaskBar1.Controls.AddRange(new System.Windows.Forms.Control[] {
																					 this.taskMenuBox1,
																					 this.taskMenuBox3});
			this.xpTaskBar1.Dock = System.Windows.Forms.DockStyle.Left;
			this.xpTaskBar1.DockPadding.Left = 10;
			this.xpTaskBar1.DockPadding.Right = 10;
			this.xpTaskBar1.DockPadding.Top = 10;
			this.xpTaskBar1.HeaderImageList = this.headerImageList;
			this.xpTaskBar1.Name = "xpTaskBar1";
			this.xpTaskBar1.Size = new System.Drawing.Size(216, 349);
			this.xpTaskBar1.TabIndex = 1;
			this.xpTaskBar1.ThemesEnabled = true;
			// 
			// headerImageList
			// 
			this.headerImageList.ColorDepth = System.Windows.Forms.ColorDepth.Depth8Bit;
			this.headerImageList.ImageSize = new System.Drawing.Size(32, 32);
			this.headerImageList.ImageStream = ((System.Windows.Forms.ImageListStreamer)(resources.GetObject("headerImageList.ImageStream")));
			this.headerImageList.TransparentColor = System.Drawing.Color.Transparent;
			// 
			// aboutLable
			// 
			this.aboutLable.Font = new System.Drawing.Font("Microsoft Sans Serif", 12F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.aboutLable.Location = new System.Drawing.Point(232, 16);
			this.aboutLable.Name = "aboutLable";
			this.aboutLable.Size = new System.Drawing.Size(280, 80);
			this.aboutLable.TabIndex = 2;
			this.aboutLable.Text = "Windows XP like Task Bar provides you quick and easy shortcuts to commonly used c" +
				"ommands and features within collapsable boxes.";
			// 
			// aboutItemsLabel
			// 
			this.aboutItemsLabel.Font = new System.Drawing.Font("Microsoft Sans Serif", 12F, System.Drawing.FontStyle.Bold);
			this.aboutItemsLabel.Location = new System.Drawing.Point(232, 112);
			this.aboutItemsLabel.Name = "aboutItemsLabel";
			this.aboutItemsLabel.Size = new System.Drawing.Size(280, 56);
			this.aboutItemsLabel.TabIndex = 3;
			this.aboutItemsLabel.Text = "Add Items with Text, Image and Click events to each XPTaskBarBox.";
			// 
			// aboutDrawingLabel
			// 
			this.aboutDrawingLabel.Font = new System.Drawing.Font("Microsoft Sans Serif", 12F, System.Drawing.FontStyle.Bold);
			this.aboutDrawingLabel.Location = new System.Drawing.Point(232, 184);
			this.aboutDrawingLabel.Name = "aboutDrawingLabel";
			this.aboutDrawingLabel.Size = new System.Drawing.Size(272, 64);
			this.aboutDrawingLabel.TabIndex = 4;
			this.aboutDrawingLabel.Text = "Draw Custom Background of the Header and Items area to get a complete XP like loo" +
				"k.";
			// 
			// label3
			// 
			this.label3.Font = new System.Drawing.Font("Microsoft Sans Serif", 12F, System.Drawing.FontStyle.Bold);
			this.label3.Location = new System.Drawing.Point(232, 256);
			this.label3.Name = "label3";
			this.label3.Size = new System.Drawing.Size(272, 88);
			this.label3.TabIndex = 5;
			this.label3.Text = "You can also place a Panel inside the XPTaskBarBox. Use XPTaskBarBox.PreferredChi" +
				"ldPanelHeight to control the height of the Panel.";
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(6, 14);
			this.BackColor = System.Drawing.Color.WhiteSmoke;
			this.ClientSize = new System.Drawing.Size(560, 349);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.label3,
																		  this.aboutDrawingLabel,
																		  this.aboutItemsLabel,
																		  this.aboutLable,
																		  this.xpTaskBar1});
			this.Font = new System.Drawing.Font("Arial", 9F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.Name = "Form1";
			this.Text = "XPTaskBar (Syncfusion Inc.)";
			this.Load += new System.EventHandler(this.Form1_Load);
			this.taskMenuBox3.ResumeLayout(false);
			this.panel1.ResumeLayout(false);
			((System.ComponentModel.ISupportInitialize)(this.xpTaskBar1)).EndInit();
			this.xpTaskBar1.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		public static void Main() 
		{
			Application.Run(new Form1());
		}

		private void Form1_Load(object sender, System.EventArgs e)
		{
			// Sample code to illustrate initializing a xpTaskBar programatically
			/*
			// <samplecodeblock name="Initializing XPTaskBar">
			XPTaskBarBox taskBarBox1 = new XPTaskBarBox();
			taskBarBox1.HeaderBackColor = Color.Blue;
			taskBarBox1.ImageList = this.imageList1;
			taskBarBox1.Text = "Header Text";
			taskBarBox1.ItemBackColor = Color.WhiteSmoke;
			taskBarBox1.Items.Add(new XPTaskBarItem("Item 1", Color.Black, 0, "Tag1"));
			taskBarBox1.Items.Add(new XPTaskBarItem("Item 2", Color.Black, 0, "Tag2"));
			taskBarBox1.ItemClick += new ItemClickHandler(xpTaskBarBox_ItemClick);

			XPTaskBarBox taskBarBox2 = new XPTaskBarBox();
			taskBarBox2.HeaderBackColor = Color.Blue;
			taskBarBox2.ImageList = this.imageList1;
			taskBarBox2.Text = "Another Header Text";
			taskBarBox2.ItemBackColor = Color.WhiteSmoke;
			taskBarBox2.Items.Add(new XPTaskBarItem("Item 3", Color.Black, 0, "Tag3"));
			taskBarBox2.ItemClick += new ItemClickHandler(this.xpTaskBarBox_ItemClick);

			this.xpTaskBar1.Controls.Add(taskBarBox1);
			this.xpTaskBar1.Controls.Add(taskBarBox2);
			//</samplecodeblock>
			*/
		}

		//<samplecodeblock name="XPTaskBar brush provider">
		private void xpTaskBarBox_ProvideHeaderBackgroundBrush(object sender, Syncfusion.Windows.Forms.Tools.ProvideBrushEventArgs args)
		{
			// Custom draw the background only when XP Themes is not available.
			if(!XPThemes.IsThemedOS || !XPThemes.IsThemeActive || !this.xpTaskBar1.ThemesEnabled)
			{
				// Blend settings
				float[] relativeIntensities = {0.0f, 0.0f, 1.0f};
				float[] relativePositions   = {0.0F, 0.5f, 1.0F};
				Blend blend = new Blend();
				blend.Factors = relativeIntensities;
				blend.Positions = relativePositions;

				XPTaskBarBox box = sender as XPTaskBarBox;

				// Header back brush
				LinearGradientBrush lgBrush = new LinearGradientBrush(args.Bounds,
					Color.White, box.HeaderBackColor, 0, true);
				lgBrush.Blend = blend;
				args.Brush = lgBrush;
			}
		}

		private void xpTaskBarBox_ProvideItemsBackgroundBrush(object sender, Syncfusion.Windows.Forms.Tools.ProvideBrushEventArgs args)
		{
			// Custom draw the background only when XP Themes is not available.
			if(!XPThemes.IsThemedOS || !XPThemes.IsThemeActive || !this.xpTaskBar1.ThemesEnabled)
			{
				if(args.Bounds.Width != 0 && args.Bounds.Height != 0)
				{
					// Blend settings
					float[] relativeIntensities = {0.0f, 0.0f, 1.0f};
					float[] relativePositions   = {0.0F, 0.5f, 1.0F};
					Blend blend = new Blend();
					blend.Factors = relativeIntensities;
					blend.Positions = relativePositions;
					// Items back brush
					LinearGradientBrush lgBrush = new LinearGradientBrush(args.Bounds,
						Color.WhiteSmoke, Color.Silver, 91, false);
					lgBrush.Blend = blend;
					args.Brush = lgBrush;
				}
			}
		}
		//</samplecodeblock>

		//<samplecodeblock name="XPTaskBar Click Handler">
		private void xpTaskBarBox_ItemClick(object sender, Syncfusion.Windows.Forms.Tools.XPTaskBarItemClickArgs e)
		{
			this.aboutDrawingLabel.BorderStyle = BorderStyle.None;
			this.aboutLable.BorderStyle = BorderStyle.None;
			this.aboutItemsLabel.BorderStyle = BorderStyle.None;

			switch(e.XPTaskBarItem.Tag as string)
			{
				case "about":
					this.aboutLable.BorderStyle = BorderStyle.FixedSingle;
					break;
				case "about items":
					this.aboutItemsLabel.BorderStyle = BorderStyle.FixedSingle;
					break;
				case "about drawing":
					this.aboutDrawingLabel.BorderStyle = BorderStyle.FixedSingle;
					break;
				case "aboutSyncfusion":
					this.ShowAboutDialog();
					break;
			}
		}
		//</samplecodeblock>
		#region AboutForm_Logic
		DemoCommon.AboutForm aboutForm = null;
		private void ShowAboutDialog()
		{
			aboutForm = new DemoCommon.AboutForm();
			aboutForm.label1.Text = "Syncfusion Essential Tools - LayoutManagers Sample";
			aboutForm.button1.Click += new EventHandler(this.AboutFormCloseBtnClicked);
			aboutForm.AcceptButton = aboutForm.button1;
			aboutForm.ShowDialog();
		}
		private void AboutFormCloseBtnClicked(object sender, EventArgs e)
		{
			aboutForm.Close();
		}
		#endregion AboutForm_Logic

		private void taskMenuBox3_CollapsedStateChanged(object sender, System.EventArgs e)
		{
			string str = "";

			this.expanded = ! this.expanded;
			
			if (this.expanded==true)
			{
				str = "Expanded";
				this.textBox1.Focus();
				this.textBox1.Text = "Has Focus";
			}
			else 		
				str = "Collapsed";
			
			MessageBox.Show(str);
		}
	}
}
